                                                        .comment        comend

  '16Bit PCM DRIVER for Mercury-Unit version 0.83 Copyright 1994,95 by BEL./nenetto'

                               Mercury Device Driver
                                        for
                       16Bit PCM Board 'Mercury-Unit V2 after'
                          Copyright 1994,95 by BEL./nenetto


                        -1      _M_IOCS         IOCS萧

                        0       _PCMOUT         PCMf[^o
                        2       _PCMAOUT        PCMf[^o(AC`F[[h)
                        6       _PCMSNS         Ԃ̒
                        7       _PCMMOD         PCMs
                        8       _MUSTAT         Mercury Unit Status

									comend

							.include	nenetto4.mac
							.cpu		68000
							.text
							.even

A_dma_ch2	equ	$e84080
A_pcm_data	equ	$ecc080
A_pcm_command	equ	$ecc091
A_pcm_status	equ	$ecc0a1
*
device_header:
	.dc.l	device_header2
	.dc.w	$8020
	.dc.l	strategy_entry_s32
	.dc.l	interrupt_entry_s32
	.dc.b	'S32     '

request_header_s32:
	.dc.l	0

jump_table_s32:
	.dc.l	init
	.dc.l	notcmd
	.dc.l	notcmd
	.dc.l	ioctrl_in
	.dc.l	input
	.dc.l	sense
	.dc.l	inpstat
	.dc.l	flush
	.dc.l	output_s32
	.dc.l	voutput_s32
	.dc.l	outstat
	.dc.l	notcmd
	.dc.l	ioctrl_out

strategy_entry_s32:
	move.l	a5,request_header_s32
	rts

interrupt_entry_s32:
	movem.l	d0/a4-a5,-(sp)
	movea.l	request_header_s32,a5
	clr.l	d0
	move.b	2(a5),d0			* command code
	add.w	d0,d0
	add.w	d0,d0
	lea.l	jump_table_s32(pc),a4
	adda.l	d0,a4
	movea.l	(a4),a4
	jsr	(a4)
	move.b	d0,3(a5)			* IXe[^X low
	lsr.w	#8,d0
	move.b	d0,4(a5)			*                high
	movem.l	(sp)+,d0/a4-a5
	rts
*
device_header2:
	.dc.l	device_header3
	.dc.w	$8020
	.dc.l	strategy_entry_s44
	.dc.l	interrupt_entry_s44
	.dc.b	'S44     '

request_header_s44:
	.dc.l	0

jump_table_s44:
	.dc.l	init
	.dc.l	notcmd
	.dc.l	notcmd
	.dc.l	ioctrl_in
	.dc.l	input
	.dc.l	sense
	.dc.l	inpstat
	.dc.l	flush
	.dc.l	output_s44
	.dc.l	voutput_s44
	.dc.l	outstat
	.dc.l	notcmd
	.dc.l	ioctrl_out

strategy_entry_s44:
	move.l	a5,request_header_s44
	rts

interrupt_entry_s44:
	movem.l	d0/a4-a5,-(sp)
	movea.l	request_header_s44,a5
	clr.l	d0
	move.b	2(a5),d0			* command code
	add.w	d0,d0
	add.w	d0,d0
	lea.l	jump_table_s44(pc),a4
	adda.l	d0,a4
	movea.l	(a4),a4
	jsr	(a4)
	move.b	d0,3(a5)			* IXe[^X low
	lsr.w	#8,d0
	move.b	d0,4(a5)			*                high
	movem.l	(sp)+,d0/a4-a5
	rts
*
device_header3:
	.dc.l	device_header4
	.dc.w	$8020
	.dc.l	strategy_entry_s48
	.dc.l	interrupt_entry_s48
	.dc.b	'S48     '

request_header_s48:
	.dc.l	0

jump_table_s48:
	.dc.l	init
	.dc.l	notcmd
	.dc.l	notcmd
	.dc.l	ioctrl_in
	.dc.l	input
	.dc.l	sense
	.dc.l	inpstat
	.dc.l	flush
	.dc.l	output_s48
	.dc.l	voutput_s48
	.dc.l	outstat
	.dc.l	notcmd
	.dc.l	ioctrl_out

strategy_entry_s48:
	move.l	a5,request_header_s48
	rts

interrupt_entry_s48:
	movem.l	d0/a4-a5,-(sp)
	movea.l	request_header_s48,a5
	clr.l	d0
	move.b	2(a5),d0			* command code
	add.w	d0,d0
	add.w	d0,d0
	lea.l	jump_table_s48(pc),a4
	adda.l	d0,a4
	movea.l	(a4),a4
	jsr	(a4)
	move.b	d0,3(a5)			* IXe[^X low
	lsr.w	#8,d0
	move.b	d0,4(a5)			*                high
	movem.l	(sp)+,d0/a4-a5
	rts
*
device_header4:
	.dc.l	device_header5
	.dc.w	$8020
	.dc.l	strategy_entry_p32
	.dc.l	interrupt_entry_p32
	.dc.b	'M32     '

request_header_p32:
	.dc.l	0

jump_table_p32:
	.dc.l	init
	.dc.l	notcmd
	.dc.l	notcmd
	.dc.l	ioctrl_in
	.dc.l	input
	.dc.l	sense
	.dc.l	inpstat
	.dc.l	flush
	.dc.l	output_p32
	.dc.l	voutput_p32
	.dc.l	outstat
	.dc.l	notcmd
	.dc.l	ioctrl_out

strategy_entry_p32:
	move.l	a5,request_header_p32
	rts

interrupt_entry_p32:
	movem.l	d0/a4-a5,-(sp)
	movea.l	request_header_p32,a5
	clr.l	d0
	move.b	2(a5),d0			* command code
	add.w	d0,d0
	add.w	d0,d0
	lea.l	jump_table_p32(pc),a4
	adda.l	d0,a4
	movea.l	(a4),a4
	jsr	(a4)
	move.b	d0,3(a5)			* IXe[^X low
	lsr.w	#8,d0
	move.b	d0,4(a5)			*                high
	movem.l	(sp)+,d0/a4-a5
	rts
*
device_header5:
	.dc.l	device_header6
	.dc.w	$8020
	.dc.l	strategy_entry_p44
	.dc.l	interrupt_entry_p44
	.dc.b	'M44     '

request_header_p44:
	.dc.l	0

jump_table_p44:
	.dc.l	init
	.dc.l	notcmd
	.dc.l	notcmd
	.dc.l	ioctrl_in
	.dc.l	input
	.dc.l	sense
	.dc.l	inpstat
	.dc.l	flush
	.dc.l	output_p44
	.dc.l	voutput_p44
	.dc.l	outstat
	.dc.l	notcmd
	.dc.l	ioctrl_out

strategy_entry_p44:
	move.l	a5,request_header_p44
	rts

interrupt_entry_p44:
	movem.l	d0/a4-a5,-(sp)
	movea.l	request_header_p44,a5
	clr.l	d0
	move.b	2(a5),d0			* command code
	add.w	d0,d0
	add.w	d0,d0
	lea.l	jump_table_p44(pc),a4
	adda.l	d0,a4
	movea.l	(a4),a4
	jsr	(a4)
	move.b	d0,3(a5)			* IXe[^X low
	lsr.w	#8,d0
	move.b	d0,4(a5)			*                high
	movem.l	(sp)+,d0/a4-a5
	rts
*
device_header6:
	.dc.l	-1
	.dc.w	$8020
	.dc.l	strategy_entry_p48
	.dc.l	interrupt_entry_p48
	.dc.b	'M48     '

request_header_p48:
	.dc.l	0

jump_table_p48:
	.dc.l	init
	.dc.l	notcmd
	.dc.l	notcmd
	.dc.l	ioctrl_in
	.dc.l	input
	.dc.l	sense
	.dc.l	inpstat
	.dc.l	flush
	.dc.l	output_p48
	.dc.l	voutput_p48
	.dc.l	outstat
	.dc.l	notcmd
	.dc.l	ioctrl_out

strategy_entry_p48:
	move.l	a5,request_header_p48
	rts

interrupt_entry_p48:
	movem.l	d0/a4-a5,-(sp)
	movea.l	request_header_p48,a5
	clr.l	d0
	move.b	2(a5),d0			* command code
	add.w	d0,d0
	add.w	d0,d0
	lea.l	jump_table_p48(pc),a4
	adda.l	d0,a4
	movea.l	(a4),a4
	jsr	(a4)
	move.b	d0,3(a5)			* IXe[^X low
	lsr.w	#8,d0
	move.b	d0,4(a5)			*                high
	movem.l	(sp)+,d0/a4-a5
	rts
*

notcmd:
	move.w	#$5003,d0			* R}h
	rts

sense:
flush:
outstat:
inpstat:
input:
ioctrl_in:
ioctrl_out:
	bra	done				* ꉞigpȂj

*
output_s32:
voutput_s32:
	movem.l	d0-d7/a0-a6,-(sp)
	clr.l	d0
	move.b	A_pcm_status,d0
	or.b	#%0001_1111,d0
	*	  ^		reserved
	*	   ^		input select
	*	    ^^		clock select	01:32KHz 02:44.1KHz 03:48KHz
	*	       ^^	panpot		R,L	0:mute 1:out
	*	         ^	type		0:monoral 1:stereo
	*	          ^	mode		0:input   1:output
	bsr	_mercury_unit_set
	bra	pcm_out_main
*
output_s44:
voutput_s44:
	movem.l	d0-d7/a0-a6,-(sp)
	clr.l	d0
	move.b	A_pcm_status,d0
	or.b	#%0010_1111,d0
	bsr	_mercury_unit_set
	bra	pcm_out_main
*
output_s48:
voutput_s48:
	movem.l	d0-d7/a0-a6,-(sp)
	clr.l	d0
	move.b	A_pcm_status,d0
	or.b	#%0011_1111,d0
	bsr	_mercury_unit_set
	bra	pcm_out_main
*
output_p32:
voutput_p32:
	movem.l	d0-d7/a0-a6,-(sp)
	clr.l	d0
	move.b	A_pcm_status,d0
	or.b	#%0001_1101,d0
	bsr	_mercury_unit_set
	bra	pcm_out_main
*
output_p44:
voutput_p44:
	movem.l	d0-d7/a0-a6,-(sp)
	clr.l	d0
	move.b	A_pcm_status,d0
	or.b	#%0010_1101,d0
	bsr	_mercury_unit_set
	bra	pcm_out_main
*
output_p48:
voutput_p48:
	movem.l	d0-d7/a0-a6,-(sp)
	clr.l	d0
	move.b	A_pcm_status,d0
	or.b	#%0011_1101,d0
	bsr	_mercury_unit_set
*
pcm_out_main:
	move.l	18(a5),size		* o͗voCg
	move.l	14(a5),data_adr		* o̓f[^̃|C^

	bsr	_init_dmac
	bsr	

	move.b	#$ff,$e84080
	bsr	_pcm_play_start
	bsr	_wait_complete

	movem.l	(sp)+,d0-d7/a0-a6
done:
	clr.w	d0
	rts

:
	move.l	#$8000,d1
	move.l	#$10000,d2

	move.l	size,d0
	lsr.l	#1,d0
	divu	d1,d0
	addq.w	#1,d0
	move.w	d0,total_block
	move.w	d0,$e8409a		* btc

	lea.l	aray_table(pc),a0
	move.l	a0,$e8409c		* bar
	movea.l	data_adr,a1
	subq.l	#1,d0
	_mk_chain_tbl:
		move.l	a1,(a0)+
		move.w	d1,(a0)+
		adda.l	d2,a1
		dbra.w	d0,_mk_chain_tbl
	swap	d0
	move.w	d0,-2(a0)
	rts

_mercury_unit_set:
	move.b	d0,A_pcm_command
	rts

_init_dmac:
	movea.l	#$e84080,a0			* DMAC ch2
	move.b	#%1111_1111,(a0)		* CSR error clear
	move.b	#%1000_1000,4(a0)		* DCR
	*	  ^^		cycle steal mode
	*	    ^^		68000 device
	*	       ^	16bit port
	*		 ^^	PCL = status
	
	move.b	#%0001_1010,5(a0)		* OCR
	*	  ^		mem > dev
	*	   ^		DONE no use
	*	    ^^		operand 16bit	* 
	*	       ^^	aray chain	
	*		 ^^	ext REQ

	move.b	#%0000_0100,6(a0)		* SCR
	*	       ^^	MAC /memory count inc.
	*		 ^^	DAC /device count fix
	move.b	#%0000_1000,7(a0)		* CCR
	*	  ^		STR /1:start
	*	   ^		CNT /1:continue use
	*	    ^		HLT /1:halt
	*	     ^		SAB /1:soft abort
	*	       ^	INT /1:int enable
	
	move.l	#$ecc080,20(a0)			* DAR
	rts

_pcm_play_start:
	movea.l	#$e84080,a0
	@@:	btst	#0,(a0)
		beq	@b
	@@:	btst	#0,(a0)
		bne	@b
	move.b	#%1000_0000,7(a0)	* DMAC start
	rts

_wait_complete:
@@:	move.b	$e84080,d0
	and.b	#$80,d0		* 1000_0000
	tst.b	d0		* H
	bne	@f
	bra	@b
@@:	move.b	#%0001_0000,$e84087		* soft abort
	rts



*
*	Mercury IOCS
*							Sun Jul 31 05:40 JST 1994 (Yui.)
*
										.even
	.dc.b	'*MD*/083'			* Fwb_
iocs_vector_f4:
	movem.l	d2-d7/a0-a6,-(sp)

	cmpi.b	#-1,d1
	beq	_merc_iocs			; Mercuryԍ -1
	cmpi.l	#0,d1
	beq	_merc_pcm_out			* Mercuryԍ 0
	cmpi.l	#2,d1
	beq	_merc_pcm_aout			* Mercuryԍ 2
	cmpi.l	#6,d1
	beq	_merc_pcm_sns			* Mercuryԍ 6
	cmpi.l	#7,d1
	beq	_merc_pcm_mod			* Mercuryԍ 7
	cmpi.l	#8,d1
	beq	_merc_unit_status		* 8

iocs:
	movem.l	(sp)+,d2-d7/a0-a6
	rts


*
_merc_unit_status:
	clr.l	d0
	move.b	A_pcm_status,d0
	bra	iocs

_merc_iocs:
	cmp.l	#0,d2
	beq	_m_iocs_fuck
	cmp.l	#1,d2
	beq	_m_iocs_unfuck

_m_iocs_check:
	moveq	#-1,d0
	tst.w	F_adpcm_fuck
	bne	@f
	clr.l	d0
	@@:
	bra	iocs

_m_iocs_fuck:
	moveq.l	#-1,d0
	tst.w	F_adpcm_fuck
	bne	iocs

	move.w	#$0160,d1
	lea.l	iocs_vector_60(pc),a1
	IOCS	_B_INTVCS
	move.l	d0,V_iocs_60_org
	
	move.w	#$0162,d1
	lea.l	iocs_vector_62(pc),a1
	IOCS	_B_INTVCS
	move.l	d0,V_iocs_62_org
	
	move.w	#$0166,d1
	lea.l	iocs_vector_66(pc),a1
	IOCS	_B_INTVCS
	move.l	d0,V_iocs_66_org
	
	move.w	#$0167,d1
	lea.l	iocs_vector_67(pc),a1
	IOCS	_B_INTVCS
	move.l	d0,V_iocs_67_org

	move.w	#-1,F_adpcm_fuck
	clr.l	d0
	bra	iocs


_m_iocs_unfuck:
	moveq.l	#-1,d0
	tst.w	F_adpcm_fuck
	beq	iocs

	move.w	#$0160,d1
	movea.l	V_iocs_60_org,a1
	IOCS	_B_INTVCS
	
	move.w	#$0162,d1
	movea.l	V_iocs_62_org,a1
	IOCS	_B_INTVCS
	
	move.w	#$0166,d1
	movea.l	V_iocs_66_org,a1
	IOCS	_B_INTVCS
	
	move.w	#$0167,d1
	movea.l	V_iocs_67_org,a1
	IOCS	_B_INTVCS

	clr.w	F_adpcm_fuck
	clr.l	d0
	bra	iocs


*
iocs_vector_60:
	movem.l	d2-d7/a0-a6,-(sp)
	move.l	d2,d3
	move.w	d1,d2
	bra	_merc_pcm_out		; _PCMOUT

*
iocs_vector_62:
	movem.l	d2-d7/a0-a6,-(sp)
	move.l	d2,d3
	move.w	d1,d2
	bra	_merc_pcm_aout		; _PCMAOUT

*
iocs_vector_66:
	movem.l	d2-d7/a0-a6,-(sp)
	bra	_merc_pcm_sns		; _PCMSNS

*
iocs_vector_67:
	movem.l	d2-d7/a0-a6,-(sp)
	move.l	d1,d2
	bra	_merc_pcm_mod		; _PCMMOD

F_adpcm_fuck:		dc.w	0	; 1 ŁAɎgɂătbNĂ.
V_iocs_60_org:		dc.l	0
V_iocs_62_org:		dc.l	0
V_iocs_66_org:		dc.l	0
V_iocs_67_org:		dc.l	0

*

_merc_pcm_sns:					* _PCMSNS
	clr.l	d0
	btst	#3,$e84080
	beq	@f
	move.l	D_pcm_mode,d0		; 
	@@:
	bra	iocs

*
_merc_pcm_mod:					* _PCMMOD
	cmpi.l	#0,d2
	beq	pcm_I
	cmpi.l	#1,d2
	beq	pcm_f
	cmpi.l	#2,d2
	beq	pcm_ĊJ
	cmpi.l	#3,d2
	beq	pcm_X[
	cmpi.l	#4,d2
	beq	pcm_X[~
	cmpi.l	#5,d2
	beq	pcm_half
	cmpi.l	#6,d2
	beq	pcm_full
pcm_I:					* ԍȂƏIidl
	move.b	#%0001_0000,$e84087		* soft abort
	bra	iocs
pcm_f:
	move.b	#%0010_0000,$e84087		* dma halt
	bra	iocs
pcm_ĊJ:
	move.b	#%0000_0000,$e84087		* release halt
	bra	iocs
pcm_X[:
	clr.l	d0
	move.b	$ecc0a1,d0
	andi.b	#%0100_0000,d0
	or.b	#%0000_1110,d0
	move.b	d0,A_pcm_command
	bra	iocs
pcm_X[~:
	clr.l	d0
	move.b	$ecc0a1,d0
	or.b	#%0000_0001,d0
	move.b	d0,A_pcm_command
	bra	iocs
pcm_half:
	clr.l	d0
	move.b	A_pcm_status,d0
	bclr.l	#7,d0
	move.b	d0,A_pcm_command
	bra	iocs

pcm_full:
	clr.l	d0
	move.b	A_pcm_status,d0
	bset.l	#7,d0
	move.b	d0,A_pcm_command
	bra	iocs

*
_merc_pcm_aout:					; _ADPCMAOUT
	move.l	a1,data_adr
	move.l	d3,size			; KvȂ?
	bsr	d2WJ

	bsr	_init_dmac

	move.w	d3,total_block		; KvȂ?
	move.w	d3,$e8409a		; btc
	move.l	a1,$e8409c		; bar

	move.b	#$ff,$e84080
	bsr	_pcm_play_start
	
	move.l	#$12,D_pcm_mode
	bra	iocs


*
_merc_pcm_out:					* _PCMOUT
	move.l	a1,data_adr
	move.l	d3,size
	bsr	d2WJ

	bsr	_init_dmac
	bsr	

	move.b	#$ff,$e84080
	bsr	_pcm_play_start
	
	move.l	#2,D_pcm_mode
	bra	iocs


d2WJ:
	clr.l	d0
	clr.l	d1
	move.w	d2,d0
	lsr.w	#8,d0
	cmp.b	#3,d0
	bcs	@f
	subq	#3,d0
	bset	#1,d1		; stereo
	@@:
	andi.b	#%0011,d0	; 0:32kHz 1:44.1kHz 2:48kHz
	addq	#1,d0
	lsl.b	#4,d0
	or.b	d0,d1
	
	lsl.w	#2,d2		; pan
	andi.w	#%1100,d2
	or.b	d2,d1
	
	tst.w	F_coaxial
	beq	@f
	bset	#7,d1		; coaxial
	@@:
	bset	#0,d1		; output
	move.b	d1,A_pcm_command
	rts

*	%0000_0000
*	 ^			1
*	  ^			INPUT SELECT  0:optical / 1:corexial
*	   ^^			CLOCK SELECT  00: BCKex / 01-11: BCKint
*	      ^^		PANPOT RG,LG
*	        ^		STEREO/MONO
*	         ^		OUT/IN

									.even
									.data
size:		.dc.l	0
data_adr:	.dc.l	0
total_block:	.dc.w	0
time:		.dc.w	0
F_coaxial:	.dc.w	0		; 1 œ
D_pcm_mode:	.dc.l	0		; _pcmsns ł̕Ԃl
aray_table:
		.ds.b	1024*2
									.text
*
*               hCo풓ɌĂ΂鏉[`
*               hCo̓o^IƂ؂
*
                                                                        .even
init:
	movem.l	a0-a6,-(sp)

	bsr	unit_check
	bne	{[hˁ`

	pea	^Cg(pc)
	DOS	_PRINT
	pea	^Cg2(pc)
	DOS	_PRINT
	addq.l	#8,sp

	bsr	IOCSg
	movem.l	(sp)+,a0-a6

	move.b	#%1000_1110,A_pcm_command		* 
	vwait	6
	btst	#0,A_pcm_status
	bne	

	pea	Ղ(pc)
	DOS	_PRINT
	addq.l	#4,sp
	bra	@f
:
	move.w	#1,F_coaxial
	move.b	#%1100_1110,A_pcm_command		* 
	vwait	6
	btst	#0,A_pcm_status
	bne	̓G[

	pea	(pc)
	DOS	_PRINT
	addq.l	#4,sp
	bra	@f
̓G[:
	move.b	#%1010_1111,A_pcm_command		* j^Ȃ
@@:
	move.l	#init,14(a5)	* foCXhCoŎgp郁̍ŏIAhX
	bra	done

{[hˁ`:
	movem.l	(sp)+,a0-a6

	pea	jbg(pc)
	DOS	_PRINT
	addq.l	#4,sp

	moveq.l	#-1,d0
	rts


IOCSg:
	clr.l	d1
	move.w	#$01f4,d1
	lea.l	iocs_vector_f4(pc),a1
	IOCS	_B_INTVCS

	pea	g(pc)
	DOS	_PRINT
	addq.l	#4,sp

	rts


unit_check:
	move.l	sp,a6
	lea.l	@f(pc),a1
	move.l	8.w,a2
	move.l	a1,8.w
	move.w	$ecc080,d0
	move.l	a2,8.w
	moveq.l	#0,d0
	rts

@@:	move.l	a6,sp
	move.l	a2,8.w
	moveq.l	#$FF,d0
	rts

*	16Bit PCM DRIVER for Mercury-Unit version x.xx Copyright 1994,95 by BEL./nenetto

^Cg:	.dc.b	13,10
		.dc.b	$1B,'[36m16Bit PCM ',$1b,'[37mDRIVER',$1b,'[0m for',$1b,'[35m Mercury-Unit',$1b,'[0m version 0.83 Copyright 1994,95 by BEL./nenetto',13,10,0
^Cg2:	.dc.b	"S32,S44,S48 / M32,M44,M48 ̊et@Cŏo͉\ł",13,10,0
g:	.dc.b	'Mercury-IOCS g܂B',13,10,0
Ղ:	.dc.b	'optical input mode.',13,10,0
:	.dc.b	'coaxial input mode.',13,10,0
jbg:	.dc.b	13,10,'Mercury-Unit ܂̂',0

		.data
	.end
